read-description:
  stage: .pre
  image: busybox
  tags: [x86_64-linux-gnu, docker, scilab]
  script:
    - awk "/Toolbox:/{print \"TBX_NAME=\"\$2}" DESCRIPTION     >build.env 
    - awk "/^Version:/{print \"TBX_VERSION=\"\$2}" DESCRIPTION >>build.env
    - cat build.env
  artifacts:
    reports:
      dotenv: build.env

source-archive:
  stage: build
  image: busybox
  tags: [x86_64-linux-gnu, docker, scilab]
  variables:
    TBX: "$TBX_NAME-$TBX_VERSION-$CI_PIPELINE_IID-src"
  script:
    - echo $TBX
    - mkdir ../$TBX && cp -a -t ../$TBX/ * && mv ../$TBX ./
    - tar czf $TBX.tar.gz $TBX
  artifacts:
    paths:
      - "$TBX.tar.gz"

x64_windows_build:
  stage: build
  tags: [x64_windows, scilab, shell]
  variables:
    TBX: "$TBX_NAME-$TBX_VERSION-$CI_PIPELINE_IID-bin"
  script:
    - echo $TBX
    - "&\"E:/nosave/work/releases/scilab-$SCI_VERSION/bin/scilab\" -nw -quit -e \"exec builder.sce\""
    - |
      echo "Copy into $TBX"
      $childItems = Get-ChildItem
      $childItems | ForEach-Object {
         Copy-Item -Path $_.FullName -Destination "$TBX" -Recurse -Force
      }
    - |
      echo "Cleanup $TBX"
      Remove-Item -Recurse -Force "$TBX\src", "$TBX\sci_gateway" -Exclude "*.dll" -erroraction ignore
      Remove-Item -Recurse -Force "$TBX\help" -erroraction ignore
      echo ""
    - Compress-Archive -Path "$TBX" -DestinationPath "$TBX-for-$SCI_VERSION.zip"
  artifacts:
    paths:
      - "$TBX-for-$SCI_VERSION.zip"
  parallel:
    matrix:
      - SCI_VERSION: ["6.1.1", "2023.1.0", "2024.0.0"]

x86_64-linux-gnu_build:
  stage: build
  image: registry.gitlab.com/scilab/scilab/linux-runner:$SCI_VERSION
  tags: [x86_64-linux-gnu, docker, scilab]
  variables:
    TBX: "$TBX_NAME-$TBX_VERSION-$CI_PIPELINE_IID-bin"
  script:
    - echo $TBX
    - scilab -nw -quit -e "exec builder.sce"
    - mkdir ../$TBX && cp -a -t ../$TBX/ * && mv ../$TBX ./
    - |
      echo "Cleanup $TBX"
      ([ -d $TBX/src ] || [ -d $TBX/sci_gateway ]) && find $TBX/src $TBX/sci_gateway ! -name "*.so*" -type f -exec rm -f {} +
      rm -fr $TBX/help
      echo ""
    - tar czf $TBX-for-$SCI_VERSION.tar.gz $TBX
  artifacts:
    paths:
      - "$TBX-for-$SCI_VERSION.tar.gz"
  parallel:
    matrix:
      - SCI_VERSION: ["6.1.1", "2023.1.0", "2024.0.0"]

x86_64-linux-gnu_test:
  stage: test
  image: registry.gitlab.com/scilab/scilab/linux-runner:$SCI_VERSION
  tags: [x86_64-linux-gnu, docker, scilab]
  variables:
    GIT_STRATEGY: none
    TBX: "$TBX_NAME-$TBX_VERSION-$CI_PIPELINE_IID-bin"
  needs:
    - read-description
    - job: x86_64-linux-gnu_build
      parallel:
        matrix:
          - SCI_VERSION: ["6.1.1", "2023.1.0", "2024.0.0"]
  script:
    - tar xzf $TBX-for-$SCI_VERSION.tar.gz
    - cd $TBX
    - scilab -nw -quit -e "test_run('.', [], [], '../results-for-'+part(getversion(), length('scilab-(+1:$)+'.xml')"
  artifacts:
    when: always
    paths:
      - "results-for-$SCI_VERSION.xml"
    reports:
      junit: "results-for-$SCI_VERSION.xml"
  parallel:
    matrix:
      - SCI_VERSION: ["6.1.1", "2023.1.0", "2024.0.0"]
